commit 9f2dc2a95f95cf52236ae0c5f41d8ef9e41ba2a8
Author: freddy77 <freddy77>
Date:   Tue Nov 4 14:46:17 2008 +0000

    more odbc tests restyling

diff --git a/ChangeLog b/ChangeLog
index 3df21ec..091ffe0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,35 @@
+Tue Nov 04 15:43:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/array.c src/odbc/unittests/array_out.c:
+	* src/odbc/unittests/attributes.c src/odbc/unittests/binary_test.c:
+	* src/odbc/unittests/blob1.c src/odbc/unittests/cancel.c:
+	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
+	* src/odbc/unittests/compute.c src/odbc/unittests/const_params.c:
+	* src/odbc/unittests/convert_error.c src/odbc/unittests/cursor1.c:
+	* src/odbc/unittests/cursor2.c src/odbc/unittests/cursor3.c:
+	* src/odbc/unittests/cursor4.c src/odbc/unittests/cursor5.c:
+	* src/odbc/unittests/cursor6.c src/odbc/unittests/cursor7.c:
+	* src/odbc/unittests/data.c src/odbc/unittests/date.c:
+	* src/odbc/unittests/describecol.c src/odbc/unittests/earlybind.c:
+	* src/odbc/unittests/error.c src/odbc/unittests/freeclose.c:
+	* src/odbc/unittests/funccall.c src/odbc/unittests/genparams.c:
+	* src/odbc/unittests/getdata.c src/odbc/unittests/hidden.c:
+	* src/odbc/unittests/insert_speed.c src/odbc/unittests/moreandcount.c:
+	* src/odbc/unittests/norowset.c src/odbc/unittests/paramcore.c:
+	* src/odbc/unittests/params.c src/odbc/unittests/prepare_results.c:
+	* src/odbc/unittests/preperror.c src/odbc/unittests/print.c:
+	* src/odbc/unittests/putdata.c src/odbc/unittests/raiserror.c:
+	* src/odbc/unittests/rebindpar.c src/odbc/unittests/rownumber.c:
+	* src/odbc/unittests/rowset.c src/odbc/unittests/rpc.c:
+	* src/odbc/unittests/scroll.c src/odbc/unittests/t0001.c:
+	* src/odbc/unittests/t0002.c src/odbc/unittests/t0003.c:
+	* src/odbc/unittests/test64.c src/odbc/unittests/testodbc.c:
+	* src/odbc/unittests/timeout.c src/odbc/unittests/timeout2.c:
+	* src/odbc/unittests/transaction.c src/odbc/unittests/transaction2.c:
+	* src/odbc/unittests/typeinfo.c src/odbc/unittests/utf8.c:
+	* src/odbc/unittests/utf8_2.c src/odbc/unittests/warning.c:
+	* src/odbc/unittests/wchar.c:
+	- more restyling
+
 Tue Nov 04 11:56:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/array_out.c src/odbc/unittests/binary_test.c:
 	* src/odbc/unittests/blob1.c src/odbc/unittests/cancel.c:
@@ -848,4 +880,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2647 2008/11/04 10:59:02 freddy77 Exp $
+$Id: ChangeLog,v 1.2648 2008/11/04 14:46:17 freddy77 Exp $
diff --git a/src/odbc/unittests/array.c b/src/odbc/unittests/array.c
index 9aa638a..9b0fd8d 100644
--- a/src/odbc/unittests/array.c
+++ b/src/odbc/unittests/array.c
@@ -3,7 +3,7 @@
 
 /* Test using array binding */
 
-static char software_version[] = "$Id: array.c,v 1.14 2007/11/26 06:25:11 freddy77 Exp $";
+static char software_version[] = "$Id: array.c,v 1.15 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char *test_query = NULL;
@@ -41,7 +41,7 @@ query_test(int prepare, SQLRETURN expected, const char *expected_status)
 	ResetStatement();
 
 	CommandWithResult(Statement, "drop table #tmp1");
-	Command(Statement, "create table #tmp1 (id tinyint, value char(20))");
+	Command("create table #tmp1 (id tinyint, value char(20))");
 
 	SQLSetStmtAttr(Statement, SQL_ATTR_PARAM_BIND_TYPE, SQL_PARAM_BIND_BY_COLUMN, 0);
 	SQLSetStmtAttr(Statement, SQL_ATTR_PARAMSET_SIZE, (void *) ARRAY_SIZE, 0);
diff --git a/src/odbc/unittests/array_out.c b/src/odbc/unittests/array_out.c
index 5117d65..1c8c8d5 100644
--- a/src/odbc/unittests/array_out.c
+++ b/src/odbc/unittests/array_out.c
@@ -3,7 +3,7 @@
 
 /* Test using array binding */
 
-static char software_version[] = "$Id: array_out.c,v 1.13 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: array_out.c,v 1.14 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char *test_query = NULL;
@@ -18,7 +18,7 @@ typedef struct
 } Record;
 
 static void
-query_test(SQLRETURN expected, const char *expected_status)
+query_test(const char* expected, const char *expected_status)
 {
 #define ARRAY_SIZE 10
 
@@ -30,7 +30,7 @@ query_test(SQLRETURN expected, const char *expected_status)
 	int desc_len = trunc ? 4 : 51;
 	int rec_size = 0;
 	Record *rec = NULL;
-	RETCODE ret;
+	RETCODE RetCode;
 	char status[20];
 
 	assert(Statement != SQL_NULL_HSTMT);
@@ -76,9 +76,7 @@ query_test(SQLRETURN expected, const char *expected_status)
 
 	CHKExecDirect((SQLCHAR *) test_query, SQL_NTS, "S");
 
-	ret = SQLFetch(Statement);
-	if (ret != expected)
-		ODBC_REPORT_ERROR("SQLFetch invalid result");
+	CHKFetch(expected);
 
 	assert(processed <= ARRAY_SIZE);
 
@@ -138,34 +136,34 @@ main(int argc, char *argv[])
 	use_odbc_version3 = 1;
 	Connect();
 
-	Command(Statement, "CREATE TABLE #odbc_test(i INT, t TEXT)");
+	Command("CREATE TABLE #odbc_test(i INT, t TEXT)");
 	for (i = 0; i < 10; ++i) {
 		char buf[128];
 
 		sprintf(buf, "INSERT INTO #odbc_test(i, t) VALUES(%d, '%crow number %d')", i + 1, 'a' + i, i * 13);
-		Command(Statement, buf);
+		Command(buf);
 	}
 
 	ResetStatement();
 
 	test_query = "SELECT * FROM #odbc_test ORDER BY i";
 	printf("test line %d\n", __LINE__);
-	query_test(SQL_SUCCESS, "VVVVVVVVVV");
+	query_test("S", "VVVVVVVVVV");
 
 	test_query = "SELECT * FROM #odbc_test WHERE i < 7 ORDER BY i";
 	printf("test line %d\n", __LINE__);
-	query_test(SQL_SUCCESS, "VVVVVV");
+	query_test("S", "VVVVVV");
 
 	/* binding row */
 	test_query = "SELECT * FROM #odbc_test ORDER BY i";
 	record_bind = 1;
 	printf("test line %d\n", __LINE__);
-	query_test(SQL_SUCCESS, "VVVVVVVVVV");
+	query_test("S", "VVVVVVVVVV");
 
 	/* row and truncation */
 	trunc = 1;
 	printf("test line %d\n", __LINE__);
-	query_test(SQL_SUCCESS_WITH_INFO, "!!!!!!!!!!");
+	query_test("I", "!!!!!!!!!!");
 
 	/* TODO bind offset, SQLGetData, no bind, error */
 
diff --git a/src/odbc/unittests/attributes.c b/src/odbc/unittests/attributes.c
index af07ad0..5e80352 100644
--- a/src/odbc/unittests/attributes.c
+++ b/src/odbc/unittests/attributes.c
@@ -5,7 +5,7 @@
  * SQLSetStmtAttr
  */
 
-static char software_version[] = "$Id: attributes.c,v 1.4 2007/12/31 10:06:50 freddy77 Exp $";
+static char software_version[] = "$Id: attributes.c,v 1.5 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
@@ -278,7 +278,7 @@ main(int argc, char *argv[])
 	Connect();
 	/* TODO find another way */
 	CheckCursor();
-	Command(Statement, "SET TEXTSIZE 4096");
+	Command("SET TEXTSIZE 4096");
 
 	SQLBindCol(Statement, 1, SQL_C_SLONG, &i, sizeof(i), &len);
 
@@ -311,7 +311,7 @@ main(int argc, char *argv[])
 				use_odbc_version3 = odbc3;
 				Disconnect();
 				Connect();
-				Command(Statement, "SET TEXTSIZE 4096");
+				Command("SET TEXTSIZE 4096");
 				SQLBindCol(Statement, 1, SQL_C_SLONG, &i, sizeof(i), &len);
 			}
 			continue;
diff --git a/src/odbc/unittests/binary_test.c b/src/odbc/unittests/binary_test.c
index f32e0b9..87f5123 100644
--- a/src/odbc/unittests/binary_test.c
+++ b/src/odbc/unittests/binary_test.c
@@ -7,7 +7,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: binary_test.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: binary_test.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define ERR_BUF_SIZE 256
@@ -42,7 +42,7 @@ clean_up(void)
 static int
 test_insert(void *buf, SQLLEN buflen)
 {
-	SQLHSTMT old_Statement;
+	SQLHSTMT Statement = SQL_NULL_HSTMT;
 	SQLLEN strlen_or_ind;
 	const char *qstr = "insert into " TEST_TABLE_NAME " values (?)";
 
@@ -50,8 +50,6 @@ test_insert(void *buf, SQLLEN buflen)
 	assert(Environment);
 
 	/* allocate new statement handle */
-	old_Statement = Statement;
-	Statement = SQL_NULL_HSTMT;
 	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &Statement, "SI");
 
 	/* execute query */
@@ -64,10 +62,9 @@ test_insert(void *buf, SQLLEN buflen)
 	CHKExecute("SI");
 
 	/* this command shouldn't fail */
-	Command(Statement, "DECLARE @i INT");
+	Command("DECLARE @i INT");
 
 	SQLFreeHandle(SQL_HANDLE_STMT, Statement);
-	Statement = old_Statement;
 	return 0;
 }
 
@@ -75,7 +72,7 @@ test_insert(void *buf, SQLLEN buflen)
 static int
 test_select(void *buf, SQLINTEGER buflen, SQLLEN * bytes_returned)
 {
-	SQLHSTMT old_Statement;
+	SQLHSTMT Statement = SQL_NULL_HSTMT;
 	SQLLEN strlen_or_ind = 0;
 	const char *qstr = "select * from " TEST_TABLE_NAME;
 
@@ -83,8 +80,6 @@ test_select(void *buf, SQLINTEGER buflen, SQLLEN * bytes_returned)
 	assert(Environment);
 
 	/* allocate new statement handle */
-	old_Statement = Statement;
-	Statement = SQL_NULL_HSTMT;
 	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &Statement, "SI");
 
 	/* execute query */
@@ -102,7 +97,6 @@ test_select(void *buf, SQLINTEGER buflen, SQLLEN * bytes_returned)
 	CHKFetch("No");
 
 	SQLFreeHandle(SQL_HANDLE_STMT, Statement);
-	Statement = old_Statement;
 	return 0;
 }
 
@@ -119,8 +113,8 @@ main(int argc, char **argv)
 
 	Connect();
 
-	Command(Statement, "create table " TEST_TABLE_NAME " (im IMAGE)");
-	Command(Statement, "SET TEXTSIZE 1000000");
+	Command("create table " TEST_TABLE_NAME " (im IMAGE)");
+	Command("SET TEXTSIZE 1000000");
 
 	/* populate test buffer with ramp */
 	for (i = 0; i < TEST_BUF_LEN; i++) {
diff --git a/src/odbc/unittests/blob1.c b/src/odbc/unittests/blob1.c
index eea40ee..66b64ea 100755
--- a/src/odbc/unittests/blob1.c
+++ b/src/odbc/unittests/blob1.c
@@ -3,7 +3,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: blob1.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: blob1.c,v 1.11 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHECK_RCODE(t,h,m) \
@@ -159,7 +159,6 @@ int
 main(int argc, char **argv)
 {
 	SQLRETURN RetCode;
-	SQLHSTMT m_hstmt = NULL;
 	SQLHSTMT old_Statement = SQL_NULL_HSTMT;
 	int i;
 
@@ -176,16 +175,16 @@ main(int argc, char **argv)
 	use_odbc_version3 = 1;
 	Connect();
 
-	Command(Statement, "CREATE TABLE #tt ( k INT, t TEXT, b1 IMAGE, b2 IMAGE, v INT )");
+	Command("CREATE TABLE #tt ( k INT, t TEXT, b1 IMAGE, b2 IMAGE, v INT )");
+
+	old_Statement = Statement;
+	Statement = SQL_NULL_HSTMT;
 
 	/* Insert rows ... */
 
 	for (i = 0; i < cnt; i++) {
 
-		m_hstmt = NULL;
-		CHKAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt, "S");
-		old_Statement = Statement;
-		Statement = m_hstmt;
+		CHKAllocHandle(SQL_HANDLE_STMT, Connection, &Statement, "S");
 
 		CHKPrepare((SQLCHAR *) "INSERT INTO #tt VALUES ( ?, ?, ?, ?, ? )", SQL_NTS, "S");
 
@@ -209,11 +208,11 @@ main(int argc, char **argv)
 		
 
 		printf(">> insert... %d\n", i);
-		CHKR(SQLExecute, (m_hstmt), "SINe");
+		CHKExecute("SINe");
 		while (RetCode == SQL_NEED_DATA) {
 			char *p;
 
-			CHKR(SQLParamData, (m_hstmt, (SQLPOINTER) & p), "SINe");
+			CHKParamData((SQLPOINTER) & p, "SINe");
 			printf(">> SQLParamData: ptr = %p  RetCode = %d\n", (void *) p, RetCode);
 			if (RetCode == SQL_NEED_DATA) {
 				if (p == buf3) {
@@ -234,18 +233,15 @@ main(int argc, char **argv)
 			}
 		}
 
-		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt, "S");
-		Statement = old_Statement;
+		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) Statement, "S");
+		Statement = SQL_NULL_HSTMT;
 	}
 
 	/* Now fetch rows ... */
 
 	for (i = 0; i < cnt; i++) {
 
-		m_hstmt = NULL;
-		CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &m_hstmt));
-		old_Statement = Statement;
-		Statement = m_hstmt;
+		CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &Statement));
 
 		if (db_is_microsoft()) {
 			CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER, "S");
@@ -271,16 +267,18 @@ main(int argc, char **argv)
 		printf(">> fetch... %d\n", i);
 
 		RetCode = readBlob(1);
-		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 1");
+		CHECK_RCODE(SQL_HANDLE_STMT, Statement, "readBlob 1");
 		RetCode = readBlob(2);
-		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 2");
+		CHECK_RCODE(SQL_HANDLE_STMT, Statement, "readBlob 2");
 		RetCode = readBlobAsChar(3, i);
-		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 3 as SQL_C_CHAR");
+		CHECK_RCODE(SQL_HANDLE_STMT, Statement, "readBlob 3 as SQL_C_CHAR");
 
 		CHKCloseCursor("S");
-		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt, "S");
-		Statement = old_Statement;
+		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) Statement, "S");
+		Statement = SQL_NULL_HSTMT;
 	}
+	
+	Statement = old_Statement;
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
index 2d2b543..b7c7ab0 100644
--- a/src/odbc/unittests/cancel.c
+++ b/src/odbc/unittests/cancel.c
@@ -78,7 +78,7 @@ main(int argc, char **argv)
 
 	ResetStatement();
 
-	Command(Statement, "SELECT name FROM sysobjects WHERE 0=1");
+	Command("SELECT name FROM sysobjects WHERE 0=1");
 
 	Disconnect();
 	return 0;
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index 2ae6150..3c18426 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,7 +12,7 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.49 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.50 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
@@ -205,15 +205,12 @@ Connect(void)
 		CheckReturn();
 	}
 
-	CHK(SQLAllocStmt, (Connection, &Statement));
+	CHKAllocStmt(&Statement, "S");
 
 	sprintf(command, "use %s", DATABASE);
 	printf("%s\n", command);
 
-	if (!SQL_SUCCEEDED(SQLExecDirect(Statement, (SQLCHAR *) command, SQL_NTS))) {
-		printf("Unable to execute statement\n");
-		CheckReturn();
-	}
+	CHKExecDirect((SQLCHAR *) command, SQL_NTS, "SI");
 
 #ifndef TDS_NO_DM
 	/* unixODBC seems to require it */
@@ -243,19 +240,6 @@ Disconnect(void)
 	return 0;
 }
 
-void
-Command(HSTMT stmt, const char *command)
-{
-	int result = 0;
-
-	printf("%s\n", command);
-	result = SQLExecDirect(stmt, (SQLCHAR *) command, SQL_NTS);
-	if (result != SQL_SUCCESS && result != SQL_NO_DATA) {
-		fprintf(stderr, "Unable to execute statement\n");
-		CheckReturn();
-	}
-}
-
 SQLRETURN
 CommandWithResult(HSTMT stmt, const char *command)
 {
@@ -327,16 +311,13 @@ void
 CheckCols(int n, int line, const char * file)
 {
 	SQLSMALLINT cols;
-	SQLRETURN res;
+	SQLRETURN RetCode;
 
-	res = SQLNumResultCols(Statement, &cols);
-	if (res != SQL_SUCCESS) {
-		if (res == SQL_ERROR && n < 0)
-			return;
-		fprintf(stderr, "%s:%d: Unable to get column numbers\n", file, line);
-		CheckReturn();
+	if (n < 0) {
+		CHKNumResultCols(&cols, "E");
+		return;
 	}
-
+	CHKNumResultCols(&cols, "S");
 	if (cols != n) {
 		fprintf(stderr, "%s:%d: Expected %d columns returned %d\n", file, line, n, (int) cols);
 		Disconnect();
@@ -348,16 +329,14 @@ void
 CheckRows(int n, int line, const char * file)
 {
 	SQLLEN rows;
-	SQLRETURN res;
+	SQLRETURN RetCode;
 
-	res = SQLRowCount(Statement, &rows);
-	if (res != SQL_SUCCESS) {
-		if (res == SQL_ERROR && n < -1)
-			return;
-		fprintf(stderr, "%s:%d: Unable to get row\n", file, line);
-		CheckReturn();
+	if (n < -1) {
+		CHKRowCount(&rows, "E");
+		return;
 	}
 
+	CHKRowCount(&rows, "S");
 	if (rows != n) {
 		fprintf(stderr, "%s:%d: Expected %d rows returned %d\n", file, line, n, (int) rows);
 		Disconnect();
@@ -370,7 +349,7 @@ ResetStatement(void)
 {
 	SQLFreeStmt(Statement, SQL_DROP);
 	Statement = SQL_NULL_HSTMT;
-	CHK(SQLAllocStmt, (Connection, &Statement));
+	CHKAllocStmt(&Statement, "S");
 }
 
 void
@@ -383,7 +362,7 @@ CheckCursor(void)
 		char output[256];
 		unsigned char sqlstate[6];
 
-		CHK(SQLGetDiagRec, (SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) output, sizeof(output), NULL));
+		CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) output, sizeof(output), NULL, "S");
 		sqlstate[5] = 0;
 		if (strcmp((const char*) sqlstate, "01S02") == 0) {
 			printf("Your connection seems to not support cursors, probably you are using wrong protocol version or Sybase\n");
@@ -442,3 +421,12 @@ AllocHandleErrType(SQLSMALLINT type)
 	}
 	return 0;
 }
+
+#undef Command
+SQLRETURN
+Command(HSTMT stmt, const char *command, const char *file, int line)
+{
+	printf("%s\n", command);
+	return CheckRes(file, line, SQLExecDirect(stmt, (SQLCHAR *) command, SQL_NTS), SQL_HANDLE_STMT, stmt, "Command", "SNo");
+}
+
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 3e6ac46..dc2ba24 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.25 2008/11/04 10:59:02 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.26 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -120,6 +120,8 @@ SQLSMALLINT AllocHandleErrType(SQLSMALLINT type);
 	CHKR2(SQLNumResultCols, (Statement,a), SQL_HANDLE_STMT, Statement, res)
 #define CHKParamData(a,res) \
 	CHKR2(SQLParamData, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKParamOptions(a,b,res) \
+	CHKR2(SQLParamOptions, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
 #define CHKPrepare(a,b,res) \
 	CHKR2(SQLPrepare, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
 #define CHKPutData(a,b,res) \
@@ -141,7 +143,8 @@ SQLSMALLINT AllocHandleErrType(SQLSMALLINT type);
 
 int Connect(void);
 int Disconnect(void);
-void Command(HSTMT stmt, const char *command);
+SQLRETURN Command(HSTMT stmt, const char *command, const char *file, int line);
+#define Command(cmd) (RetCode=Command(Statement, cmd, __FILE__, __LINE__))
 SQLRETURN CommandWithResult(HSTMT stmt, const char *command);
 int db_is_microsoft(void);
 const char *db_version(void);
diff --git a/src/odbc/unittests/compute.c b/src/odbc/unittests/compute.c
index 20bca06..1ade523 100644
--- a/src/odbc/unittests/compute.c
+++ b/src/odbc/unittests/compute.c
@@ -9,7 +9,7 @@
  * and declared in odbcss.h
  */
 
-static char software_version[] = "$Id: compute.c,v 1.11 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: compute.c,v 1.12 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char col1[256], col2[256];
@@ -78,12 +78,12 @@ main(int argc, char *argv[])
 {
 	Connect();
 
-	Command(Statement, "create table #tmp1 (c varchar(20), i int)");
-	Command(Statement, "insert into #tmp1 values('pippo', 12)");
-	Command(Statement, "insert into #tmp1 values('pippo', 34)");
-	Command(Statement, "insert into #tmp1 values('pluto', 1)");
-	Command(Statement, "insert into #tmp1 values('pluto', 2)");
-	Command(Statement, "insert into #tmp1 values('pluto', 3)");
+	Command("create table #tmp1 (c varchar(20), i int)");
+	Command("insert into #tmp1 values('pippo', 12)");
+	Command("insert into #tmp1 values('pippo', 34)");
+	Command("insert into #tmp1 values('pluto', 1)");
+	Command("insert into #tmp1 values('pluto', 2)");
+	Command("insert into #tmp1 values('pluto', 3)");
 
 
 	/* 
@@ -95,7 +95,7 @@ main(int argc, char *argv[])
 	/* select * from #tmp1 compute sum(i) */
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
-	Command(Statement, "select * from #tmp1 order by c, i compute sum(i)");
+	Command("select * from #tmp1 order by c, i compute sum(i)");
 	CheckFetch("c", "pippo", "12");
 	CheckFetch("c", "pippo", "34");
 	CheckFetch("c", "pluto", "1");
@@ -118,7 +118,7 @@ main(int argc, char *argv[])
 	/* select * from #tmp1 order by c compute sum(i) by c */
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
-	Command(Statement, "select c as mao, i from #tmp1 order by c, i compute sum(i) by c compute max(i)");
+	Command("select c as mao, i from #tmp1 order by c, i compute sum(i) by c compute max(i)");
 	CheckFetch("mao", "pippo", "12");
 	CheckFetch("mao", "pippo", "34");
 	CHKFetch("No");
@@ -160,7 +160,7 @@ main(int argc, char *argv[])
 	/* select * from #tmp1 where i = 2 compute min(i) */
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
-	Command(Statement, "select * from #tmp1 where i = 2 or i = 34 order by c, i compute min(i) by c");
+	Command("select * from #tmp1 where i = 2 or i = 34 order by c, i compute min(i) by c");
 	CheckFetch("c", "pippo", "34");
 	CHKFetch("No");
 	CHKMoreResults("S");
diff --git a/src/odbc/unittests/const_params.c b/src/odbc/unittests/const_params.c
index 92bbbf2..7b9b225 100644
--- a/src/odbc/unittests/const_params.c
+++ b/src/odbc/unittests/const_params.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?,123,'foo')} syntax and run */
 
-static char software_version[] = "$Id: const_params.c,v 1.15 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: const_params.c,v 1.16 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -17,7 +17,7 @@ main(int argc, char *argv[])
 	if (CommandWithResult(Statement, "drop proc const_param") != SQL_SUCCESS)
 		printf("Unable to execute statement\n");
 
-	Command(Statement, "create proc const_param @in1 int, @in2 int, @in3 datetime, @in4 varchar(10), @out int output as\n"
+	Command("create proc const_param @in1 int, @in2 int, @in3 datetime, @in4 varchar(10), @out int output as\n"
 		"begin\n"
 		" set nocount on\n"
 		" select @out = 7654321\n"
@@ -43,7 +43,7 @@ main(int argc, char *argv[])
 	}
 
 	/* just to reset some possible buffers */
-	Command(Statement, "DECLARE @i INT");
+	Command("DECLARE @i INT");
 
 	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind,  "S");
 	CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2, "S");
@@ -67,9 +67,9 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 
-	Command(Statement, "IF OBJECT_ID('const_param') IS NOT NULL DROP PROC const_param");
+	Command("IF OBJECT_ID('const_param') IS NOT NULL DROP PROC const_param");
 
-	Command(Statement, "create proc const_param @in1 float, @in2 varbinary(100) as\n"
+	Command("create proc const_param @in1 float, @in2 varbinary(100) as\n"
 		"begin\n"
 		" if @in1 <> 12.5 or @in2 <> 0x0102030405060708\n"
 		"  return 12345\n"
@@ -88,9 +88,9 @@ main(int argc, char *argv[])
 		return 1;
 	}
 
-	Command(Statement, "drop proc const_param");
+	Command("drop proc const_param");
 
-	Command(Statement, "create proc const_param @in varchar(20) as\n"
+	Command("create proc const_param @in varchar(20) as\n"
 		"begin\n"
 		" if @in = 'value' select 8421\n"
 		" select 1248\n"
@@ -98,7 +98,7 @@ main(int argc, char *argv[])
 
 	/* catch problem reported by Peter Deacon */
 	output = 0xdeadbeef;
-	Command(Statement, "{CALL const_param('value')}");
+	Command("{CALL const_param('value')}");
 	CHKBindCol(1, SQL_C_SLONG, &output, 0, &ind, "S");
 	SQLFetch(Statement);
 
@@ -109,7 +109,7 @@ main(int argc, char *argv[])
 
 	ResetStatement();
 
-	Command(Statement, "drop proc const_param");
+	Command("drop proc const_param");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/convert_error.c b/src/odbc/unittests/convert_error.c
index 676adf0..0310c84 100644
--- a/src/odbc/unittests/convert_error.c
+++ b/src/odbc/unittests/convert_error.c
@@ -4,7 +4,7 @@
  */
 #include "common.h"
 
-static char software_version[] = "$Id: convert_error.c,v 1.9 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: convert_error.c,v 1.10 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int test_num = 0;
@@ -37,7 +37,7 @@ main(int argc, char **argv)
 	use_odbc_version3 = 1;
 	Connect();
 
-	Command(Statement, "create table #test_output (id int, msg text)");
+	Command("create table #test_output (id int, msg text)");
 
 	Test("?", SQL_INTEGER, "?", SQL_LONGVARCHAR);
 	Test("123", SQL_INTEGER, "?", SQL_LONGVARCHAR);
diff --git a/src/odbc/unittests/cursor1.c b/src/odbc/unittests/cursor1.c
index e19fb2c..f282a19 100644
--- a/src/odbc/unittests/cursor1.c
+++ b/src/odbc/unittests/cursor1.c
@@ -2,7 +2,7 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: cursor1.c,v 1.17 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor1.c,v 1.18 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SWAP_STMT(b) do { SQLHSTMT xyz = Statement; Statement = b; b = xyz; } while(0)
@@ -47,14 +47,14 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 	SQLRETURN RetCode;
 
 	/* create test table */
-	Command(Statement, "IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
-	Command(Statement, create_sql);
+	Command("IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
+	Command(create_sql);
 	for (i = 1; i <= 6; ++i) {
 		char sql_buf[80], data[10];
 		memset(data, 'a' + (i - 1), sizeof(data));
 		data[i] = 0;
 		sprintf(sql_buf, insert_sql, data, i);
-		Command(Statement, sql_buf);
+		Command(sql_buf);
 	}
 
 	/* set cursor options */
@@ -149,8 +149,8 @@ static void
 Test(int use_sql)
 {
 	CommandWithResult(Statement, "DROP TABLE #a");
-	Command(Statement, "CREATE TABLE #a(x int)");
-	Command(Statement, "INSERT INTO #a VALUES(123)");
+	Command("CREATE TABLE #a(x int)");
+	Command("INSERT INTO #a VALUES(123)");
 	Test0(use_sql, "CREATE TABLE #test(i int, c varchar(6))", "INSERT INTO #test(c, i) VALUES('%s', %d)", "SELECT x AS i, c FROM #test, #a");
 
 	Test0(use_sql, "CREATE TABLE #test(i int, c varchar(6))", "INSERT INTO #test(c, i) VALUES('%s', %d)", "SELECT i, c FROM #test");
diff --git a/src/odbc/unittests/cursor2.c b/src/odbc/unittests/cursor2.c
index 9d261f6..8a9cd6c 100644
--- a/src/odbc/unittests/cursor2.c
+++ b/src/odbc/unittests/cursor2.c
@@ -2,7 +2,7 @@
 
 /* Test cursor do not give error for statement that do not return rows  */
 
-static char software_version[] = "$Id: cursor2.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor2.c,v 1.6 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -14,7 +14,7 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	Command(Statement, "CREATE TABLE #cursor2_test (i INT)");
+	Command("CREATE TABLE #cursor2_test (i INT)");
 
 	retcode = SQLSetConnectAttr(Connection, SQL_ATTR_CURSOR_TYPE,  (SQLPOINTER) SQL_CURSOR_DYNAMIC, SQL_IS_INTEGER);
 	if (retcode != SQL_SUCCESS) {
@@ -31,7 +31,7 @@ main(int argc, char *argv[])
 	ResetStatement();
 
 	/* this should not fail or return warnings */
-	Command(Statement, "DROP TABLE #cursor2_test");
+	Command("DROP TABLE #cursor2_test");
 
 	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL, "No");
 
diff --git a/src/odbc/unittests/cursor3.c b/src/odbc/unittests/cursor3.c
index abe3513..b0d621b 100644
--- a/src/odbc/unittests/cursor3.c
+++ b/src/odbc/unittests/cursor3.c
@@ -1,7 +1,7 @@
 /* Tests 2 active statements */
 #include "common.h"
 
-static char software_version[] = "$Id: cursor3.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor3.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -18,11 +18,11 @@ main(int argc, char **argv)
 
 	CheckCursor();
 
-	Command(Statement, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
-	Command(Statement, "INSERT INTO #t1 VALUES (1, 'aaa')");
-	Command(Statement, "INSERT INTO #t1 VALUES (2, 'bbbbb')");
-	Command(Statement, "INSERT INTO #t1 VALUES (3, 'ccccccccc')");
-	Command(Statement, "INSERT INTO #t1 VALUES (4, 'dd')");
+	Command("CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
+	Command("INSERT INTO #t1 VALUES (1, 'aaa')");
+	Command("INSERT INTO #t1 VALUES (2, 'bbbbb')");
+	Command("INSERT INTO #t1 VALUES (3, 'ccccccccc')");
+	Command("INSERT INTO #t1 VALUES (4, 'dd')");
 
 	old_Statement = Statement;
 
diff --git a/src/odbc/unittests/cursor4.c b/src/odbc/unittests/cursor4.c
index 9f228b5..8a34220 100755
--- a/src/odbc/unittests/cursor4.c
+++ b/src/odbc/unittests/cursor4.c
@@ -5,19 +5,17 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: cursor4.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor4.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 exec_direct(const char *stmt)
 {
-	SQLHSTMT old_Statement = Statement;
+	SQLHSTMT Statement = SQL_NULL_HSTMT;
 
-	Statement = SQL_NULL_HSTMT;
 	CHKAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & Statement, "S");
-	Command(Statement, stmt);
+	Command(stmt);
 	CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) Statement, "S");
-	Statement = old_Statement;
 }
 
 int
diff --git a/src/odbc/unittests/cursor5.c b/src/odbc/unittests/cursor5.c
index ea8d459..b394ec0 100755
--- a/src/odbc/unittests/cursor5.c
+++ b/src/odbc/unittests/cursor5.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: cursor5.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor5.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLINTEGER v_int_3;
@@ -31,10 +31,10 @@ main(int argc, char **argv)
 
 	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (SQLPOINTER) SQL_AUTOCOMMIT_ON, SQL_IS_UINTEGER, "S");
 
-	Command(Statement, "create table #mytab1 (k int, c char(30))");
-	Command(Statement, "insert into #mytab1 values (1,'aaa')");
-	Command(Statement, "insert into #mytab1 values (2,'bbb')");
-	Command(Statement, "insert into #mytab1 values (3,'ccc')");
+	Command("create table #mytab1 (k int, c char(30))");
+	Command("insert into #mytab1 values (1,'aaa')");
+	Command("insert into #mytab1 values (2,'bbb')");
+	Command("insert into #mytab1 values (3,'ccc')");
 
 	ResetStatement();
 /*	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_STATIC, 0, "S");	*/
diff --git a/src/odbc/unittests/cursor6.c b/src/odbc/unittests/cursor6.c
index 6f3e431..6a05f29 100755
--- a/src/odbc/unittests/cursor6.c
+++ b/src/odbc/unittests/cursor6.c
@@ -2,7 +2,7 @@
 
 /* Test SQLFetchScroll with no binded columns */
 
-static char software_version[] = "$Id: cursor6.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor6.c,v 1.5 2008/11/04 14:46:17 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int bind_all = 0;
@@ -79,10 +79,10 @@ static void Init(void)
 	int i;
 	char sql[128];
 
-	Command(Statement, "CREATE TABLE #cursor6_test (i INT, c VARCHAR(20))");
+	Command("CREATE TABLE #cursor6_test (i INT, c VARCHAR(20))");
 	for (i = 1; i <= 10; ++i) {
 		sprintf(sql, "INSERT INTO #cursor6_test(i,c) VALUES(%d, 'a%db%dc%d')", i, i, i, i);
-		Command(Statement, sql);
+		Command(sql);
 	}
 
 }
